---
title: "2020 Survey, Soil Quality Relationships."
subtitle: "Non Grain Crops"
author: "Bionutrient Institute"
date: "`r format( Sys.Date(), '%m/%d/%Y' )`"
output:
  html_document:
    default: true
    keep_md: true
    toc: true
    toc_float: true
    toc_collapsed: true
    toc_depth: 3
    number_sections: true
---


```{r init,echo=FALSE,warnings=FALSE}

trainAgain <- FALSE
trainAgainGeneral <- FALSE
trainAgainLong <- FALSE

library("MASS")
library("kableExtra")
library("furrr")
library(knitr)
library(GGally)
library("caret")
library("DT")
library("doParallel")
source("../scripts/trainHelpers.R")
source("../scripts/plotHelpers.R")
source("../scripts/positionStatistics.R")

farmersTable <- read_rds( "../dataset/fullTableParsed.Rds" )

theme_set(theme_gray(base_size = 24))

knitr::opts_chunk$set(
                    fig.width=7,
                    fig.height=10,
                    echo=FALSE,
                    warning=FALSE,
                    message=FALSE
                  )

farmersTable <- farmersTable %>%
  mutate(
    soil_scan_10cm_365 = ( soil10.scan_vis.data.median_365 + soil10.scan_vis_2.data.median_365 ) / 2,
    soil_scan_10cm_385 = ( soil10.scan_vis.data.median_385 + soil10.scan_vis_2.data.median_385 ) / 2,
    soil_scan_10cm_450 = ( soil10.scan_vis.data.median_450 + soil10.scan_vis_2.data.median_450 ) / 2,
    soil_scan_10cm_500 = ( soil10.scan_vis.data.median_500 + soil10.scan_vis_2.data.median_500 ) / 2,
    soil_scan_10cm_530 = ( soil10.scan_vis.data.median_530 + soil10.scan_vis_2.data.median_530 ) / 2,
    soil_scan_10cm_587 = ( soil10.scan_vis.data.median_587 + soil10.scan_vis_2.data.median_587 ) / 2,
    soil_scan_10cm_632 = ( soil10.scan_vis.data.median_632 + soil10.scan_vis_2.data.median_632 ) / 2,
    soil_scan_10cm_850 = ( soil10.scan_vis.data.median_850 + soil10.scan_vis_2.data.median_850 ) / 2,
    soil_scan_10cm_880 = ( soil10.scan_vis.data.median_880 + soil10.scan_vis_2.data.median_880 ) / 2,
    soil_scan_10cm_940 = ( soil10.scan_vis.data.median_940 + soil10.scan_vis_2.data.median_940 ) / 2,
    soil_scan_20cm_365 = ( soil20.scan_vis.data.median_365 + soil20.scan_vis_2.data.median_365 ) / 2,
    soil_scan_20cm_385 = ( soil20.scan_vis.data.median_385 + soil20.scan_vis_2.data.median_385 ) / 2,
    soil_scan_20cm_450 = ( soil20.scan_vis.data.median_450 + soil20.scan_vis_2.data.median_450 ) / 2,
    soil_scan_20cm_500 = ( soil20.scan_vis.data.median_500 + soil20.scan_vis_2.data.median_500 ) / 2,
    soil_scan_20cm_530 = ( soil20.scan_vis.data.median_530 + soil20.scan_vis_2.data.median_530 ) / 2,
    soil_scan_20cm_587 = ( soil20.scan_vis.data.median_587 + soil20.scan_vis_2.data.median_587 ) / 2,
    soil_scan_20cm_632 = ( soil20.scan_vis.data.median_632 + soil20.scan_vis_2.data.median_632 ) / 2,
    soil_scan_20cm_850 = ( soil20.scan_vis.data.median_850 + soil20.scan_vis_2.data.median_850 ) / 2,
    soil_scan_20cm_880 = ( soil20.scan_vis.data.median_880 + soil20.scan_vis_2.data.median_880 ) / 2,
    soil_scan_20cm_940 = ( soil20.scan_vis.data.median_940 + soil20.scan_vis_2.data.median_940 ) / 2
  ) 

variablesOfInterest <- c(
  "Type",
  "Antioxidants",
  "Polyphenols",
  "Proteins",
  "climateRegion",
  "variety",
  "sample_source",
  "soilOrder",
  "soilSuborder",
  ## This UID is generated at the data pre processing level to anonymize farms. It identifies farms.
  "uid"
)


cropMineralVars <- farmersTable %>%
  select( contains( "produce_xrf" ) ) %>%
  select( - contains( "raw" ), - contains( "_alt_" ), -contains("final") ) %>%
  colnames

bqiMinerals <-  c(
  'produce_xrf_Mg',
  'produce_xrf_S',
  'produce_xrf_K',
  'produce_xrf_Ca',
  'produce_xrf_Fe',
  'produce_xrf_Zn'
)

bqiSymbols <- str_remove( bqiMinerals, "produce_xrf_" )

soilHealthVars <- c(
  "organic_carbon_percentage_10cm",
  "organic_carbon_percentage_20cm",
  "PH_soil_10cm",
  "PH_soil_20cm",
  "respiration_soil_10cm",
  "respiration_soil_20cm"
)


dataframe <-  farmersTable %>%
  filter( ( intake_survey != "grain" ) ) %>%
  mutate(
    `farm_irrigation.nonchlorine_water` = `farm_irrigation.nonchlorine_water` | `farm_irrigation.well` | `farm_irrigation.surface`,
    `covercropping.practiced` = .data[[ "farm_practices.covercrops" ]], 
    `covercropping.none` = !.data[[ "farm_practices.covercrops" ]],
    `tillage.none` = `land_prep.notill`,
    ## `land_prep.none` =  !`land_prep.notill` &
    ##   !`land_prep.broadforking` &
    ##   !`land_prep.solarization` &
    ##   !`land_prep.sheet_mulching`,
    ## `land_prep.none` = ifelse( is.na( `land_prep.none` ) & `land_prep.tillage`, FALSE, `land_prep.none` )                          ) %>%
    `land_prep.none` = `land_prep.tillage`
  ) %>%
  select(
    "lab_id",
    "id_sample",
    "uid",
    "Type",
    "variety",
    "sample_source",
    "Polyphenols",
    "Antioxidants",
    "Brix",
    "BQI",
    "climateRegion",
    "cropColor",
    "state",
    "companion_cropping",
    "soilOrder",
    "store_name",
    "store_brand",
    "soil_type",
    slope,
    organic_matter_level,
    matches( "^farm_practices" ),
    matches( "^amendments" ),
    matches( "^tillage" ),
    matches( "^farm_irrigation" ),
    matches( "^seed_treatment" ),
    matches( "^covercropping" ),
    matches( "^land_prep" ),
    matches( "^surface.scan" ),
    matches( "^juice.scan" ),
    matches( "^whole.scan" ),
    matches( "it_1$" ),
    contains("soil_scan_"),
    !!cropMineralVars,
    !!soilHealthVars,
    contains( "respiration_soil" ),
    "soilSuborder",
    "soilOrder",
    ) %>%
  mutate_at( vars( !!soilHealthVars, !!cropMineralVars ), ~ ifelse( .x < 0 , NA, .x ) ) %>%
  mutate(
    sample_source = ifelse(is.na(sample_source), "unknown", sample_source ),
    "companion_cropping.none" = map_lgl( companion_cropping, ~ !.x ),
    "companion_cropping.true" = map_lgl( companion_cropping, ~ .x )
  ) %>%
  select(
    - "farm_irrigation.well",
    - "farm_irrigation.surface",
    - "farm_practices.covercrops",
    - "land_prep.tillage"
    )

farmPracticesCols <- dataframe %>%
  select( matches("^farm_practices.") ) %>%
  colnames
amendmentsCols <- dataframe %>%
  select( matches("^amendments") ) %>%
  colnames
seedTreatmentCols <- dataframe %>%
  select( matches("^seed_treatment") ) %>%
  colnames
tillageCols <- dataframe %>%
  select( matches("^tillage") ) %>%
  colnames
irrigationCols <- dataframe %>%
  select( matches("^farm_irrigation") ) %>%
  colnames
coverCols <- dataframe %>%
  select( matches("^covercropping") ) %>%
  colnames
landPrepCols <- dataframe %>%
  select( matches("^land_prep") ) %>%
  colnames
factorsList <- dataframe %>%
  select( matches("^farm_practices."), matches("^amendments."), matches("^seed_treatment."), matches( "^tillage." ), matches("^farm_irrigation"), matches("^covercropping"), matches("^land_prep") ) %>%
  colnames

```


# Context and Purpose of this Brief

  This document concentrates our analysis around soil health indicators. Our main intentions are **measuring impact of soil helath over our crop quality variables**, **assesment of the potential of this variables to add predictive power to our machine learning models** and **summarising and testing the effects of management practices over soil health indicators**.


#### Crop Nutritional Density Variables

```{r variables,echo=FALSE,warning=FALSE}

explained <- tribble(
  ~ Nutritional,
  "Antioxidants",
  "Polyphenols",
  "Brix",
  "BQI"
  )

explicative <- tibble( Soil = c( soilHealthVars, "respiration_soil_10cm", "respiration_soil_20cm" ) )

explained %>% kable( caption = "Crop Nutritional Density Variables" ) %>% kable_styling(
                                                                            c( "hover", "striped" ),
                                                                            full_width = FALSE,
                                                                            fixed_thead = TRUE
                                                          )

samplesInvolved <- tibble(
  BothDepthSamlples = farmersTable %>% filter( str_detect( involved_surveys, "soil10" ) &  str_detect( involved_surveys, "soil20" ) ) %>% nrow,
  Just10cm = farmersTable %>% filter( str_detect( involved_surveys, "soil10" ) &  !str_detect( involved_surveys, "soil20" ) ) %>% nrow,
  Just20cm = farmersTable %>% filter( str_detect( involved_surveys, "soil20" ) &  !str_detect( involved_surveys, "soil10" ) ) %>% nrow,
  )

samplesInvolved %>% kable( caption="Involved Samples, by Depth Registered" )  %>% kable_styling(
                                                                                    c( "hover", "striped" ),
                                                                                    full_width = FALSE,
                                                                                    fixed_thead = TRUE
                                                                                  )


```

### Soil Health Variables

```{r}
explicative %>% kable( caption = "Soil Health Variables" ) %>% kable_styling(
                                                                 c( "hover", "striped" ),
                                                                 full_width = FALSE,
                                                                 fixed_thead = TRUE
                                                                            )
bfaTable <- dataframe %>%
  filter( !is.na(Type) ) %>%
  select( explicative$Soil %>% keep( !str_detect( ., "PH_soil" ) ), Type ) %>%
  mutate_at( vars( - Type ), ~ ifelse( .x < 0, NA, .x ) ) %>%
  pivot_longer( cols = c(organic_carbon_percentage_10cm, organic_carbon_percentage_20cm, respiration_soil_10cm, respiration_soil_20cm ), names_to = "variable", values_to = "value" ) %>%
  mutate(
    depth = str_match( variable, "10cm|20cm" ),
    variable = str_remove( variable, "_10cm|_20cm" )
  ) %>%
  group_by( Type, depth, variable ) %>%
  summarise_all(
    list( median = median,
         max = max,
         min = min,
         "range"=function(x,na.rm){ max(x,na.rm=na.rm) - min(x,na.rm=na.rm) },
         sd = sd,
         "ratio"=function(x,na.rm){ max(x,na.rm=na.rm) / min(x,na.rm=na.rm) }
         ),
    na.rm = TRUE
  )

bfaTable <- bfaTable %>%
  ## group_by( Type, depth, variable ) %>%
  pivot_wider( names_from = c( depth, variable ), values_from = c( median, max, min, range, sd, ratio ) ) %>%
  select( Type, contains("10cm"), contains("20cm") )

write_csv( bfaTable, path="./BFA-Soil-Extremes-Table.csv" )

```

* The following table is available as a CSV file for manipulation, filename `./BFA-Soil-Extremes-Table.csv`.

```{r bfaTableSoil}

datatable( bfaTable,
          extensions = "Buttons",
          options = ( list(
            dom = "Bfrtipl",
            lengthMenu = c( 10,20, 40, 80 ),
            buttons = I("colvis")
          )
          ) )

```

## Methodologies

  We've performed an extensive medians comparisons in the past for crop nutritional quality indicators ( *antioxidants*, *polyphenols* and *brix* ). Methods, code implementations and a detailed guide on how we are interpreting results are all detailed on a previous brief available on the same site where this one is offered, *2019 Survey, Quality Relationships Analysis*.

  The predictive potential and impact of soil health indicators over nutritional density indicators will be measured by a non parametrical measure of correlation, *Spearman's Rank Correlation Coefficient*, in line with the rank tests employed for median shifts on our *Quality Relationships* synthesis tables.


```{r echo=TRUE, warning=FALSE, echo=FALSE}

generalMediansTable <- tibble()

studiedVariables <- c(
  "PH_soil_10cm",
  "PH_soil_20cm",
  "respiration_soil_10cm",
  "respiration_soil_20cm",
  "organic_carbon_percentage_10cm",
  "organic_carbon_percentage_20cm",
  "uid"
)

soilTables <- function( variable, factors = factorsList, data = dataframe, imgBaseDir="./graphics/soil/", reportToGenTable = TRUE ) {
  output <- list()

  filtArray <- tribble(
    ~ variable, ~ value,
    ## "crop", selCrop
  )

  cropDF <- data %>%
    ## filter( crop == selCrop ) %>%
    select( !!studiedVariables,
           !!factors,
           uid
           )

  output$df <- cropDF

  output$mediansPractices <- pmap_df( enframe( farmPracticesCols, name = NULL ), ~ positionStatisticsByLogicColumn(
                                                                                  data = cropDF,
                                                                                  column = .x,
                                                                                  explained = variable,
                                                                                  center = "farm_practices.none"
                                                                                )
                                     ) %>% filter( N != 0 )

  output$mediansAmendments <- pmap_df( enframe( amendmentsCols, name = NULL ), ~ positionStatisticsByLogicColumn(
                                                                                data = cropDF,
                                                                                column = .x,
                                                                                explained = variable,
                                                                                center = "amendments.none"
                                                                              )
                                      ) %>% filter( N != 0 )
  output$mediansSeedTreatment <- pmap_df( enframe( seedTreatmentCols, name = NULL ), ~ positionStatisticsByLogicColumn(
                                                                                      data = cropDF,
                                                                                      column = .x,
                                                                                      explained = variable,
                                                                                      center = "seed_treatment.none"
                                                                                    )
                                         ) %>% filter( N != 0 )

  output$mediansTillage <- pmap_df( enframe( tillageCols, name = NULL ), ~ positionStatisticsByLogicColumn(
                                                                          data = cropDF,
                                                                          column = .x,
                                                                          explained = variable,
                                                                          center = "tillage.none"
                                                                        )
                                   ) %>% filter( N != 0 )

  output$mediansIrrigation <- pmap_df( enframe( irrigationCols, name = NULL ), ~ positionStatisticsByLogicColumn(
                                                                          data = cropDF,
                                                                          column = .x,
                                                                          explained = variable,
                                                                          center = "farm_irrigation.none"
                                                                        )
                                   ) %>% filter( N != 0 )

  output$mediansCover <- pmap_df( enframe( coverCols, name = NULL ), ~ positionStatisticsByLogicColumn(
                                                                                data = cropDF,
                                                                                column = .x,
                                                                                explained = variable,
                                                                                center = "covercropping.none"
                                                                              )
                                      ) %>% filter( N != 0 )
  output$mediansLandPrep <- pmap_df( enframe( landPrepCols, name = NULL ), ~ positionStatisticsByLogicColumn(
                                                                      data = cropDF,
                                                                      column = .x,
                                                                      explained = variable,
                                                                      center = "land_prep.none"
                                                                    )
                                 ) %>% filter( N != 0 )

  if ( reportToGenTable ) {

    medPract <- output$mediansPractices %>% mutate( explained = variable,
                                                   ## crop =selCrop,
                                                   family = "practices"
                                                  )
    medAmend <- output$mediansAmendments %>% mutate( explained = variable,
                                                   ## crop =selCrop,
                                                   family = "amendments"
                                                   )
    medTil <- output$mediansTillage %>% mutate( explained = variable,
                                                    ## crop =selCrop,
                                                    family = "tillage"
                                                    )
    medIrrigation <- output$mediansIrrigation %>% mutate( explained = variable,
                                               ## crop =selCrop,
                                               family = "farm_irrigation"
                                               )
    medCover <- output$mediansCover %>% mutate( explained = variable,
                                                         ## crop =selCrop,
                                                         family = "covercropping"
                                                         )
    medLandPrep <- output$mediansLandPrep %>% mutate( explained = variable,
                                               ## crop =selCrop,
                                               family = "land_prep"
                                               )
    medSeedT <- output$mediansSeedTreatment %>% mutate( explained = variable,
                                               ## crop =selCrop,
                                               family = "seed_treatment"
                                               )
    generalTable <- bind_rows( generalMediansTable,
                              medPract,
                              medAmend,
                              medTil,
                              medIrrigation,
                              medCover,
                              medLandPrep,
                              medSeedT )
    assign( "generalMediansTable", generalTable, envir = .GlobalEnv )
  }

  return( output )
}

dataframe <- dataframe %>% mutate( respiration_soil_10cm = as.double( respiration_soil_10cm ) )
dataframe <- dataframe %>% mutate( respiration_soil_20cm = as.double( respiration_soil_20cm ) )
dataframe <- dataframe %>% mutate( organic_carbon_percentage_10cm = as.double( organic_carbon_percentage_10cm ) )
dataframe <- dataframe %>% mutate( organic_carbon_percentage_20cm = as.double( organic_carbon_percentage_20cm ) )


PH10cm <- soilTables( variable = "PH_soil_10cm" , factors = factorsList, data = dataframe, imgBaseDir="./graphics/", reportToGenTable = TRUE )

PH20cm <- soilTables( variable = "PH_soil_20cm" , factors = factorsList, data = dataframe, imgBaseDir="./graphics/", reportToGenTable = TRUE )

respiration10cm <- soilTables( variable = "respiration_soil_10cm" , factors = factorsList, data = dataframe, imgBaseDir="./graphics/", reportToGenTable = TRUE )

respiration20cm <- soilTables( variable = "respiration_soil_20cm" , factors = factorsList, data = dataframe, imgBaseDir="./graphics/", reportToGenTable = TRUE )

organic10 <- soilTables( variable = "organic_carbon_percentage_10cm", factors = factorsList, data = dataframe, imgBaseDir="./graphics/", reportToGenTable = TRUE )

organic20 <- soilTables( variable = "organic_carbon_percentage_20cm", factors = factorsList, data = dataframe, imgBaseDir="./graphics/", reportToGenTable = TRUE )


generalMediansTable <-  generalMediansTable %>% arrange( factor, explained, - N )
write_rds( x= generalMediansTable, file="./soilMediansTable.Rds" )
write_csv( x= generalMediansTable, file="./soilMediansTable.csv" )


synthesisTable <- generalMediansTable %>%
  filter( isRelevant == TRUE & !is.na( isRelevant ) ) %>%
  select( factor, family, explained, N, p.value, intervalMin, intervalMax ) %>%
  pivot_wider( names_from = c( explained ), values_from = c( N, p.value, intervalMin, intervalMax ) ) %>%
  mutate(
    family = str_extract( string = factor, pattern = "^[a-z_]*(?=.)" ),
    factor = str_replace( string = factor, pattern = "^[a-z_]*\\.", replacement = "" )
  )


amendmentsSynthesis <- synthesisTable %>% filter( family == "amendments" )
practicesSynthesis <- synthesisTable %>% filter( family == "practices" )
tillageSynthesis <- synthesisTable %>% filter( family == "tillage" )

write_rds( x = amendmentsSynthesis, path=".soilAmendmentsSynthesisTable.Rds" )
write_csv( x = amendmentsSynthesis, path=".soilAmendmentsSynthesisTable.csv" )
write_rds( x = practicesSynthesis, path=".soilPracticesSynthesisTable.Rds" )
write_csv( x = practicesSynthesis, path=".soilPracticesSynthesisTable.csv" )

referenceValues <- generalMediansTable %>%
  filter( str_detect( string = factor, pattern="none" ) ) %>%
  select( factor, "HL Estimate", explained, family ) %>%
  mutate( reference = .data[["HL Estimate"]] ) %>%
  select( explained, family, reference )

generalMediansTable <- left_join( x= generalMediansTable, y = referenceValues, by=c( "explained", "family") )

relevantsTable <- generalMediansTable %>%
  filter( observedUIDs >= 3 ) %>%
  mutate( shiftPercentage = .data[['HL Median Shift Estimate']] / reference,
         shiftPercentage = round( shiftPercentage * 100, digits = 2 )
         ## shiftPercentage = round( shiftPercentage * 100, digits = 2 ) %>% str_c( ., "%", sep ="" )
         ) %>%
  select( factor, explained, shiftPercentage, family ) %>%
  pivot_wider( names_from = explained, values_from = c( shiftPercentage ) ) %>%
  ## mutate( factor = str_replace( string = factor, pattern = "(amendments.)|(farm_practices.)", replacement = "" ) ) %>%
  mutate( factor = str_replace( string = factor, pattern = "^[a-z_]*\\.", replacement = "" ) ) %>%
  select( factor, family, contains("10cm"), contains("20cm") )

sampleSizesTable <- generalMediansTable %>%
  filter( observedUIDs >= 3 ) %>%
  select( factor, explained, family, N ) %>%
  pivot_wider( names_from = c( explained ), values_from = c( N ) ) %>%
  ## mutate( factor = str_replace( string = factor, pattern = "(amendments.)|(farm_practices.)", replacement = "" ) ) %>%
  mutate( factor = str_replace( string = factor, pattern = "^[a-z_]*\\.", replacement = "" ) ) %>%
  select( factor, family, contains("10cm"), contains("20cm") )

pValuesTable <- generalMediansTable %>%
  filter( observedUIDs >= 3 ) %>%
  mutate(
    isRelevant = ( intervalMax < 0 ) | ( intervalMin > 0 ),
    p.value = ifelse( p.value > 0.1 & isRelevant == TRUE, 0.09, p.value  )
  ) %>%
  select( factor, explained, family, p.value ) %>%
  pivot_wider( names_from = c( explained ), values_from = c( p.value ) ) %>%
  ## mutate( factor = str_replace( string = factor, pattern = "(amendments.)|(farm_practices.)", replacement = "" ) ) %>%
  mutate( factor = str_replace( string = factor, pattern = "^[a-z_]*\\.", replacement = "" ) ) %>%
  select( factor, family, contains("10cm"), contains("20cm") )


relevants <- relevantsTable %>%
  select( - contains("PH") )

formatCols <- relevants %>% select( -"factor", -"family" ) %>%
  colnames

fullColorPractices <- fragmentColoredTable( relevants, cropsList, "practices", explainedVariables = soilHealthVars )

fullColorAmendments <- fragmentColoredTable( relevants, cropsList, "amendments", explainedVariables = soilHealthVars )

fullColorTillage <- fragmentColoredTable( relevants, cropsList, "tillage", explainedVariables = soilHealthVars )

fullColorIrrigation <- fragmentColoredTable( relevants, cropsList, "farm_irrigation", explainedVariables = soilHealthVars )
fullColorCovecropping <- fragmentColoredTable( relevants, cropsList, "covercropping", explainedVariables = soilHealthVars )
fullColorLandPrep <- fragmentColoredTable( relevants, cropsList, "land_prep", explainedVariables = soilHealthVars )

```


```{r correlations}

generalFitsTable <- tibble()

soilGraphics <- function( selCrop, variable, data = dataframe, imgBaseDir="./graphics/regressions/" ) {

  output <- list()

  filtArray <- tribble(
    ~ variable, ~ value,
    "Type", selCrop
  )

  table1 <- data %>%
    filter( Type == selCrop ) %>%
    select( !!studiedVariables, !!sym(variable), id_sample, - uid ) %>%
    na.omit

  cropDF <- table1 %>% select( -id_sample )

  output$df <- cropDF

  if ( nrow( cropDF ) < 10 ) { return(NA) };

  ## correlations <- cor( cropDF, method = "kendall" )

  ## heatmap <- ggcorr(
  ##   cropDF,
  ##   method = c( "pairwise", "spearman" ),
  ##   nbreaks = 6,
  ##   hjust = 0.8,
  ##   label = TRUE,
  ##   label_size = 3,
  ##   color = "grey50"
  ## )

  ## output$heatmap <- heatmap

  modelFormula <- paste0( variable, "~" ,"." ) %>% as.formula
  model1 <- lm( formula = modelFormula , cropDF, singular.ok = TRUE )
  summary1 <- summary( model1 )
  output$summary1 <- summary1
  output$model1 <- model1

  dataLength <- model1$residuals %>% length()
  chop <-  model1$residuals %>% abs() %>% sort %>% tail( ceiling( dataLength * 0.15 ) ) %>% names %>% as.integer()

  model2 <- lm( formula = modelFormula , ( cropDF %>% slice( - chop ) ), singular.ok = TRUE )
  summary2 <- summary( model2 )
  output$modelN <- dataLength
  output$summary2 <- summary2
  output$model2 <- model2
  output$chopped = table1 %>% slice( chop ) %>% select( id_sample )

  ## get F test p value
  fStatisticPValue1 <-  1-pf( q=summary1$fstatistic[1], df1= summary1$fstatistic[2], df2 = summary1$fstatistic[3] ) %>% .[[1]]
  fStatisticPValue2 <-  1-pf( q=summary2$fstatistic[1], df1= summary2$fstatistic[2], df2 = summary2$fstatistic[3] ) %>% .[[1]]

  ## get p values of t test
  tTestTable <- model2 %>%
    broom::tidy() %>%
    select( term, "p.value" ) %>%
    mutate( `p.value` = round( `p.value`, 4 ) ) %>%
    pivot_wider( names_from = term, values_from = `p.value` ) %>%
    rename_all( ~ str_c( "t test p.val " , . ) )

  fitSummary <- tribble(
    ~ "Crop", ~ "Variable", ~"Samples", ~"R2", ~ "F test p-value", ~"trimmed R2", ~ "F test p-value, trimmed",
    selCrop, variable, dataLength, summary1$adj.r.squared, fStatisticPValue1, summary2$adj.r.squared, fStatisticPValue2
  )

  ## get coefficients
  coefficients2 <- summary2 %>%
    broom::tidy() %>%
    select( term, estimate ) %>%
    pivot_wider( names_from = term, values_from = estimate ) %>%
    rename( Intercept = `(Intercept)` ) %>%
    rename_all( ~ str_c( "coefficient_", . ) ) %>%
    rename_all( ~ str_remove_all( ., "(organic\\_)|(percentage\\_)|(soil\\_)" ) ) %>%
    mutate_all( ~ round( ., 2 ) )

  fitSummary <- bind_cols( fitSummary, tTestTable, coefficients2 )

  generalTable <- bind_rows( fitSummary , generalFitsTable )
  
  assign( "generalFitsTable", generalTable, envir = .GlobalEnv )


  return( output )

}

cropsList <- dataframe %>% select( Type ) %>% unique %>% na.omit

allNutrientsLM <- crossing(
  species = cropsList %>% unlist,
  explained = explained %>% unlist
)

allNutrientsLM <- allNutrientsLM %>%
  mutate(
    modelsAndPlots = map2( allNutrientsLM$species, allNutrientsLM$explained, ~ soilGraphics( selCrop = .x, variable = .y, data = dataframe, imgBaseDir = "./graphics/regressions" ) )
)

generalFitsTable <- generalFitsTable %>% arrange( - .data[["trimmed R2"]] )

write_csv( generalFitsTable, "./linearModelsComparison.csv" )

variableSets <- list(
  bionutrientMeter = c( dataframe %>% select( contains("soil_scan") ) %>% colnames ),
  bionutrientMeter10cm = c( dataframe %>% select( contains("soil_scan_10cm") ) %>% colnames ),
  bionutrientMeter20cm = c( dataframe %>% select( contains("soil_scan_20cm") ) %>% colnames ),
  scsMetadata = c( "soil_type", "slope", "organic_matter_level" ),
  scsMetadata10cm = c( "soil_type", "slope", "organic_matter_level" ),
  scsMetadata20cm = c( "soil_type", "slope", "organic_matter_level" ),
  climateRegion = c( "climateRegion" ),
  medFarmPractices = c( dataframe %>% select( contains( "farm_practices." ) ) %>% select( -contains( "tillage" ) ) %>% colnames ),
  "PH_soil_10cm" = c("PH_soil_10cm"),
  "PH_soil_20cm" = c("PH_soil_20cm"),
  juice = dataframe %>% select( contains("juice.scan") ) %>% colnames,
  surface = dataframe %>% select( contains("surface.scan") ) %>% colnames
)


datasets <- list(
    set1 = soilHealthVars,
    set2 = c( soilHealthVars, variableSets$surface ),
    set3 = c( soilHealthVars, variableSets$juice ),
    set4 = c( soilHealthVars, variableSets$surface, variableSets$juice )
  )

allSoilModels <- crossing(
      explained = c( "Antioxidants", "Polyphenols", "Brix", "BQI" ),
      species = cropsList %>% unlist,
      dataset = datasets %>% names
      )

if ( trainAgain ) {

  cluster <- makePSOCKcluster(48)
  registerDoParallel(cluster)

  ## testTree <- regressionTree( "Polyphenols", "lettuce", "set2", dataframe, kFolds = 5, verbose = TRUE )

  allRF <- allSoilModels
  allRF <- allRF %>% mutate(
                                     model = pmap(  list( allRF$explained, allRF$species, allRF$dataset ), ~regressionTree( ..1, ..2, ..3, dataframe ), kFolds = 8 )
                     )

  allRF <- allRF %>% mutate(
                       cvRsquared = map_dbl( model, ~ .x$results %>%
                                                      arrange( -Rsquared ) %>%
                                                      select(Rsquared) %>%
                                                      slice(1) %>%
                                                      unlist ),
                       mtry = model %>% map_dbl( ~ .x["bestTune"] %>% unlist ),
                       N = map_dbl( model, ~ .x$trainingData %>% tibble %>% nrow ),
                       y = map( model, ~ .x$finalModel$y ),
                       y_predicted = map( model, ~ .x$finalModel$predicted ),
                       importance = map( model, ~ .x$finalModel$importance )
                       )
  stopCluster(cluster)

  write_rds( allRF, path = "../bigFiles/nonGrainSoilRF.Rds" )

  allRF <- allRF %>%
    filter( N > 0 ) %>%
    mutate(
      intervalsObject = pmap( list( model, explained, N), function( model, explained, N ) { if ( N > 0 ) { return( getIntervalsTable(model, explained) ) } else { return(NA) } } ),
      covers = intervalsObject %>% map_dbl( ~ .x["observedCoverPercentage"] %>% unlist ),
      width = intervalsObject %>% map_dbl( ~ .x["medianWidthToRangeRatio"] %>% unlist )
    )



  lightSoilRegressions <- allRF %>%
    select( -model )

  write_rds( lightSoilRegressions, "./lightSoilRegressions.Rds" )
  rm( "allRF" )
  }


lightSoilRegressions <- read_rds( "./lightSoilRegressions.Rds" )

lightRFTable <- lightSoilRegressions %>%
  arrange( species, explained, cvRsquared ) %>%
  select( - importance, - y, - y_predicted )

longTable <- getLongIntervalsTable( lightSoilRegressions )

datasetGroups <- list(
  "soilPredictors" = c("set1", "set2", "set3", "set4")
)

cropGroups <- list(
  "Fruit" = c( "peppers", "zucchini", "apple", "squash_butternut" ),
  "Root" = c( "beet", "carrot", "potato" )
 ## ,
  ## "Greens1" = c( "kale", "lettuce" ),
  ## "Greens2" = c( "bok_choi", "mustard_greens", "swiss_chard" )
)

if  ( trainAgain )  {

  plan(multisession, workers = 24)
  allFitPlots <- crossing(
    explained = longTable %>% select(explained) %>% unique %>% unlist,
    datasetGroup = datasetGroups %>% names,
    cropGroup = cropGroups %>% names
  )

  allFitPlots <- allFitPlots %>%
    mutate(
          fitPlotPath =  future_pmap_chr( list( explained, datasetGroup, cropGroup ), ~ drawFitPlotsGrid( longTable, ..1, ..2, ..3 ) )
        )

  allFitPlots <- allFitPlots %>%
    mutate(
      importancePlotPath = future_pmap_chr( list( explained, datasetGroup, cropGroup ), ~ plotAllImportanceByVariable( lightSoilRegressions, explainedVarName =  ..1, modelsListName =  ..2, cropGroupsName =  ..3 ) )
    )

  allFitPlots  <- allFitPlots %>% write_rds( "./graphics/fitPlots/namesTable.Rds" )
} else {
  allFitPlots  <- read_rds( "./graphics/fitPlots/namesTable.Rds" )
}

```

## Models and Crop Groups

```{r}
cropGroups %>% kable( caption = "Crop Grouping" )  %>% kable_styling(
                                                         c( "hover", "striped" ),
                                                         full_width = FALSE,
                                                         fixed_thead = TRUE
                                                       )


datasetsTable <- tibble()

for ( set in names( datasets ) ) {
  current <- datasets[[set]] %>% as_tibble %>% mutate( dataset = set )
  datasetsTable <- bind_rows( datasetsTable, current )
}

datasetsTable %>%
  select( dataset, value ) %>%
  kable( caption = "Composition of datasets" )  %>% kable_styling(
                                                      c( "hover", "striped" ),
                                                      full_width = FALSE,
                                                      fixed_thead = TRUE
                                                    )

```


## Boxplots for Soil Health Variables Over Climate Regions


```{r}

variablesOfInterest <- c( variablesOfInterest, soilHealthVars )

sizesClimateRegion <- dataframe %>%
  filter( !is.na( `organic_carbon_percentage_10cm`) ) %>%
  group_by( climateRegion ) %>%
  summarise( N = n() )

## to position the labels showing sample size
explainedVarMin <- dataframe[[ "organic_carbon_percentage_10cm" ]] %>% min( ., na.rm = TRUE )

climateRegion10cm <-   dataframe %>%
  select( organic_carbon_percentage_10cm, "climateRegion" ) %>%
  mutate( climateRegion = as_factor(climateRegion) ) %>%
  na.omit() %>%
  ggplot() +
  aes( y = organic_carbon_percentage_10cm, fill = climateRegion, x=as.factor( climateRegion ) ) +
  geom_boxplot() +
  geom_label( data = sizesClimateRegion, aes( label = str_c( "N=", N, sep = "" ) ), y = explainedVarMin, nudge_y = 900, size = 4 ) +
  theme(
    axis.text.x = element_text( angle = 90, hjust = 1 ),
    legend.position = "top"
  ) +
  guides( fill = "none" ) +
  labs(
    y = "Organic Carbon Percentage 10cm",
    x = "Climate Region",
    fill = "Climate Region",
    title = paste( "Organic Carbon Percentage 10cm", "on", "Soil Grain", sep = " " ),
    subtitle = "Boxplots for Each Climate Region"
  ) 
filePath <- paste0("./graphics/boxplots/","Boxplot-","SoilGrain","-","organic_carbon_percentage_10cm","-climateRegion.png")
ggsave(  filename=filePath, device = "png", width=16, height = 12  )
climateRegion10cm

sizesClimateRegion <- dataframe %>%
  filter( !is.na( `organic_carbon_percentage_20cm`) ) %>%
  group_by( climateRegion ) %>%
  summarise( N = n() )

climateRegion20cm <-   dataframe %>%
  select( organic_carbon_percentage_20cm, "climateRegion" ) %>%
  mutate( climateRegion = as_factor(climateRegion) ) %>%
  na.omit() %>%
  ggplot() +
  aes( y = organic_carbon_percentage_20cm, fill = climateRegion, x=as.factor( climateRegion ) ) +
  geom_boxplot() +
  geom_label( data = sizesClimateRegion, aes( label = str_c( "N=", N, sep = "" ) ), y = explainedVarMin, nudge_y = 900, size = 4 ) +
  theme(
    axis.text.x = element_text( angle = 90, hjust = 1 ),
    legend.position = "top"
  ) +
  guides( fill = "none" ) +
  labs(
    y = "Organic Carbon Percentage 20cm",
    x = "Climate Region",
    fill = "Climate Region",
    title = paste( "Organic Carbon Percentage 20cm", "on", "Soil Grain", sep = " " ),
    subtitle = "Boxplots for Each Climate Region"
  ) 
filePath <- paste0("./graphics/boxplots/","Boxplot-","SoilGrain","-","organic_carbon_percentage_20cm","-climateRegion.png")
ggsave(  filename=filePath, device = "png", width=16, height = 12  )
climateRegion20cm

```


# Cuantification of Soil Quality Variables over Produce Quality Variables

  As stated, we are measuring correlation between soil and nutritional variables for each crop.
  Two linear regressions will be adjusted for each crop, explaining a nutritional variable with all six soil variables.
  
  On a first step, a **first linear model** is adjusted for all the explicative variables and all data points available. Then an **$\alpha$ trimming** is performed for the $15%$ biggest residuals and a **second model** is adjusted with this high residuals trimmmed dataset.
  
  We don't expect such a simple regression to yield a complete prediction of this variables, which have proven remarkably complex to predict in a regressive context. Good $R^2$ results will inform that this variables are good material to increase the predictive power of our current complex models, like Random Forests which already employ spectrometry, regions, varieties, etc.

## Fit Quality on Each Crop and Variable

* **Trimmed** models are thos were an alfa trimming has been performed: after a first run, the 15% worst residual samples are removed and a new model is trained over the clean dataset.
* The **F Test** p value is offered for both models.
* The **T test** p values are offered just for the trimmed models. No Bonferroni correction has been applied, so the reader should bear in mind that for 6 variables to give the desired confidence, the threshold p value should be divided by 6 ( that is, to satisfy a level 0.05 we need to see 0.083 on the t test ).

```{r regressionsFit, echo=FALSE}

datatable( generalFitsTable,
          extensions = "Buttons",
          options = ( list(
            dom = "Bfrtipl",
            lengthMenu = c( 12,24, 36 ),
            buttons = I("colvis")
          )
          ) )

```

### Residuals Graphics for the Most Promissing Regressions

#### Antioxidants on Oats

```{r oatsAnti, echo=F}

## oatsAntioxidants <- tibble(
##   Residuals = oatsAntioxidantsCors$model2$residuals,
##   Antioxidants = oatsAntioxidantsCors$model2$model$Antioxidants,
##   Fitted = oatsAntioxidantsCors$model2$fitted.values
## )

## oatsAntioxidantsNotTrimmed <- tibble(
##   Residuals = oatsAntioxidantsCors$model1$residuals,
##   Antioxidants = oatsAntioxidantsCors$model1$model$Antioxidants,
##   Fitted = oatsAntioxidantsCors$model1$fitted.values
## )


## oatsAntioxidants %>%
##   ggplot() +
##   aes( x = Antioxidants, y = Residuals ) +
##   geom_point() +
##   labs(
##     title = "Residuals vs Values, Trimmed"
##   )

## oatsAntioxidantsNotTrimmed %>%
##   ggplot() +
##   aes( x = Antioxidants, y = Residuals ) +
##   geom_point() +
##   labs(
##     title = "Residuals vs Values, not Trimmed"
##   )

## oatsAntioxidants %>%
##   ggplot() +
##   aes( x = Antioxidants, y = Fitted ) +
##   geom_point() +
##   labs(
##     title = "Training Values vs Fitted Values"
##   )

## oatsAntioxidants %>%
##   ggplot() +
##   aes( sample = Residuals ) +
##   geom_qq() +
##   geom_qq_line() +
##   labs(
##     title = "QQ Plot for Residuals"
##   )

```

# Random Forest Regressions

This random forest models are cross validated and include several other variables sets, to help better compare the importance of our soil predictors in comparison with other available information, which in this case is the hand spectrometer scans.

## Datasets

```{r rfdatasets}

datasetsTable <- tibble(
  name = datasets %>%names,
  variables = datasets
)

datasetsTable %>% kable( caption = "composition of datasets" ) %>% kable_styling(
                                                                     c( "hover", "striped" ),
                                                                     full_width = FALSE,
                                                                     fixed_thead = TRUE
)

```

## Observed Results


```{r}

datatable( lightRFTable,
          extensions = "Buttons",
          options = ( list(
            dom = "Bfrtipl",
            lengthMenu = c( 10,20, 40, 80 ),
            buttons = I("colvis")
          )
          ) )

```

# Quality of Fit, interval Width and Importance Metrics for Each Crop { .tabset }

## Antioxidants { .tabset }


```{r fitsAndImportanceAntioxidants, echo=FALSE, results="asis"}

antioxidantsFitPlots <- allFitPlots %>% filter( explained == "Antioxidants" )

template <- "### %s
#### Fit Plot 

![Image](%s)

#### Importance Plot 

![Image](%s)

"

pwalk( list( antioxidantsFitPlots$cropGroup, antioxidantsFitPlots$fitPlotPath, antioxidantsFitPlots$importancePlotPath ), ~ cat( sprintf( template, ..1, ..2, ..3 ) ) )
```

## Polyphenols { .tabset }


```{r fitsAndImportancePolyphenols, echo=FALSE, results="asis"}

polyphenolsFitPlots <- allFitPlots %>% filter( explained == "Polyphenols" )

template <- "### %s
#### Fit Plot 

![Image](%s)

#### Importance Plot 

![Image](%s)

"

pwalk( list( polyphenolsFitPlots$cropGroup, polyphenolsFitPlots$fitPlotPath, polyphenolsFitPlots$importancePlotPath ), ~ cat( sprintf( template, ..1, ..2, ..3 ) ) )
```

## Brix { .tabset }


```{r fitsAndImportanceBrix, echo=FALSE, results="asis"}

brixFitPlots <- allFitPlots %>% filter( explained == "Brix" )

template <- "### %s
#### Fit Plot 

![Image](%s)

#### Importance Plot 

![Image](%s)

"

pwalk( list( brixFitPlots$cropGroup, brixFitPlots$fitPlotPath, brixFitPlots$importancePlotPath ), ~ cat( sprintf( template, ..1, ..2, ..3 ) ) )
```

## BQI { .tabset }


```{r fitsAndImportanceBQI, echo=FALSE, results="asis"}

BQIFitPlots <- allFitPlots %>% filter( explained == "BQI" )

template <- "### %s
#### Fit Plot 

![Image](%s)

#### Importance Plot 

![Image](%s)

"

pwalk( list( BQIFitPlots$cropGroup, BQIFitPlots$fitPlotPath, BQIFitPlots$importancePlotPath ), ~ cat( sprintf( template, ..1, ..2, ..3 ) ) )
```



# Quality Relationship Tables

  We offer separatedly the synthesis of this tables on the same site were this brief is available, showing the shifts as percentages of deviation over the median and the sample sizes. 
  
  This variables have shown interesting behaviours. As we are not accounting for the crop factor, populations are robust for most evaluated practices, and most of them have shown shifts that our test could detect as significant. 
  
  Tables offered below are much deeper so the recommended procedure is searching for interesting data on the synthesis tables, and then getting a deeper insight by looking at the complete summaries. 
  
  Besites the medians shift analysis, we've performed a much more informal summary for the frequency of factors on certaing percentiles. The intuitive idea behind this procedure is that if the frequency of *Practice X* over the whole dataset is $30%$ but while looking at the "10%" biggest values for the vaiable it doubles to $60%$, it is probably *concentrated* among the most succesfull crops. There are tables for the best and worst percentiles showing this behaviour. 
  
  It's main advantage is that it spares the reader looking at the enormuos amount of graphics that would have been involved in comparint all these factors for each of the three variables and that it shows patterns even while not detected as relevant by the test, could be interesting for certain investigators or worth an additional exploration.

## Percentual Shift Over the Median Value for Farm Practices

### p.values Code Key

```{r, echo=FALSE }
codeKey <- read_rds( "./pValuesCodeKey.Rds" )
codeKey

farmPracticesReference <- dataframe %>%
  filter( `farm_practices.none`, !is.na(`organic_carbon_percentage_10cm`) |
                                 !is.na(`organic_carbon_percentage_20cm`) |
                                 !is.na(`respiration_soil_10cm`) |
                                 !is.na(`respiration_soil_20cm`) 
         ) %>%
  nrow

amendmentsReference <- dataframe %>%
  filter( `amendments.none`, !is.na(`organic_carbon_percentage_10cm`) |
                             !is.na(`organic_carbon_percentage_20cm`) |
                             !is.na(`respiration_soil_10cm`) |
                             !is.na(`respiration_soil_20cm`) 
         ) %>%
  nrow
tillageReference <- dataframe %>%
  filter( `tillage.none`, !is.na(`organic_carbon_percentage_10cm`) |
                          !is.na(`organic_carbon_percentage_20cm`) |
                          !is.na(`respiration_soil_10cm`) |
                          !is.na(`respiration_soil_20cm`) 
         ) %>%
  nrow
irrigationReference <- dataframe %>%
  filter( `farm_irrigation.none`, !is.na(`organic_carbon_percentage_10cm`) |
                                  !is.na(`organic_carbon_percentage_20cm`) |
                                  !is.na(`respiration_soil_10cm`) |
                                  !is.na(`respiration_soil_20cm`) 
         ) %>%
  nrow
covercroppingReference <- dataframe %>%
  filter( `covercropping.none`, !is.na(`organic_carbon_percentage_10cm`) |
                                !is.na(`organic_carbon_percentage_20cm`) |
                                !is.na(`respiration_soil_10cm`) |
                                !is.na(`respiration_soil_20cm`) 
         ) %>%
  nrow
landPrepReference <-  dataframe %>%
  filter( `land_prep.none`, !is.na(`organic_carbon_percentage_10cm`) |
                            !is.na(`organic_carbon_percentage_20cm`) |
                            !is.na(`respiration_soil_10cm`) |
                            !is.na(`respiration_soil_20cm`) 
         ) %>%
  nrow

```

## Percentual Shift Over the Median for FarmP Practices 

The reference category for this table are farms that informed they do not employ any of these management techniques. The size of that reference sample is `r farmPracticesReference` .

```{r practices , echo=FALSE}
fullColorPractices
```

## Percentual Shift Over the Median for Soil Amendments

The reference category are farms that informed they do not use soil amendments.The size of that reference sample is `r amendmentsReference` .

```{r amendments, echo=FALSE}
fullColorAmendments
```

## Percentual Shift Over the Median for Tillage Intensity

The reference category are farms informing they avoid tillage. The size of that reference sample is `r tillageReference` .

```{r tillage, echo=FALSE}
fullColorTillage
```

## Percentual Shift Over the Median for Irrigation


The reference category are farms informing no irrigation. The size of that reference sample is `r irrigationReference` .

```{r irrigation, echo=FALSE}
fullColorIrrigation
```

## Percentual Shift Over the Median for Covercrop

The reference category are farms informing no cover crops. The size of that reference sample is `r covercroppingReference` .

```{r covercropping, echo=FALSE}
fullColorCovecropping
```

## Percentual Shift Over the Median for Land Preparation Techniques


The reference category are farms informing that they use any form of tillage. The size of that reference sample is `r landPrepReference` .

```{r landPrepo, echo=FALSE}
fullColorLandPrep
```


```{r savingSession}
save.image( "../bigFiles/nonGrainSoilSession.RSession" )
```

